/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.c
* Author             : WCH
* Version            : V1.0
* Date               : 2019/4/29
* Description 		 : SPI1 Flashдʾ
*******************************************************************************/

#include "CH57x_common.h"
#include "Driver_diskio.h"
//#include "W25Qxx.H"
#include "SPI_MSD_Driver.H"
#include "elog.h"
#include "elog_cfg.h"


/* Private variables ---------------------------------------------------------*/
FATFS       fs;         /* Work area (file system object) for logical drive */
FIL         fsrc;         /* file objects */   
FRESULT     res;
UINT        br;

char path[256]="0:";
uint8_t textFileBuffer[] = "Thank you for using Development Board ^_^ \r\n";   



void DebugInit(void)		
{
    GPIOA_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_8, GPIO_ModeIN_PU);
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
}


UINT8  buf[512]; 
/*******************************************************************************
* Function Name  : scan_files
* Description    : ļĿ¼ļ
* Input          : - path: Ŀ¼
* Output         : None
* Return         : FRESULT
* Attention		 : ֳ֧ļ
*******************************************************************************/
FRESULT scan_files (char* path)
{
    FILINFO fno;
    DIR dir;
    int i;
    char *fn;

    res = f_opendir(&dir, path);
    if (res == FR_OK) 
    {
        i = strlen(path);
        for (;;) 
        {
            res = f_readdir(&dir, &fno);           
            
            if (res != FR_OK || fno.fname[0] == 0) break;
            if (fno.fname[0] == '.') continue;
#if _USE_LFN
            fn = *fno.fname ? fno.fname : fno.altname;
#else
            fn = fno.fname;
#endif
            
            if (fno.fattrib & AM_DIR) 
            {
                sprintf(&path[i], "/%s", fn);
                res = scan_files(path);
                if (res != FR_OK) break;
                path[i] = 0;
            } else {
                DEBUG_OUT("%s/%s ", path, fn);
            }            
        }
        f_closedir(&dir);
        
    }else   DEBUG_OUT("f_opendir %s error %d!\r\n",path,res);    
    return res;
}
/*******************************************************************************
* Function Name  : SD_TotalSize
* Description    : ļռռ
* Input          : None
* Output         : None
* Return         : 1ɹ 0ʧ
* Attention		 : None
*******************************************************************************/
int SD_TotalSize(char* path)
{
    FATFS *fs;
    DWORD fre_clust;        

    res = f_getfree(path, &fre_clust, &fs);  /* ǸĿ¼ѡ0 */
    if ( res==FR_OK ) 
    {
	  /* Print free space in unit of MB (assuming 512 bytes/sector) */
      DEBUG_OUT("\r\n%u KB total drive space.\r\n"
           "%u KB available.\r\n",
           (int)(((fs->n_fatent - 2) * fs->csize ) / 2 ) , (int)((fre_clust * fs->csize) / 2  ));
		
	  return ENABLE;
	}else	  return DISABLE;   
}


int main(void)
{
//    UINT32      i,j;
//    uint32_t    addr;
    uint8_t     *p;    
    MSD_CARDINFO cardinfo;
    
    
    DelayMs(20);
    DebugInit( );        // Խӿ UART1    
    elog_init();     
        
    FATFS_Init(); 
            
    if(MSD_Init() == 0)
    {
        MSD_GetCardInfo(&cardinfo);
        if(MSD_ReadSingleBlock(0,buf) == 0)
        {
            p = buf;
            elog_hexdump("TF Card Sector Data:",16,p,512); 
        } 
        
        f_mount(&fs,"0:",1);
        res = f_open( &fsrc , "0:/Demo.TXT" , FA_CREATE_NEW | FA_WRITE);
        if ( res == FR_OK )
        { 
          /* Write buffer to file */
          res = f_write(&fsrc, textFileBuffer, sizeof(textFileBuffer), &br);   
          DEBUG_OUT("Demo.TXT successfully created        \r\n\r\n");
        
          /*close file */
          f_close(&fsrc);      
        }else if ( res == FR_EXIST )
        {
          DEBUG_OUT("Demo.TXT created in the disk      \r\n\r\n");
        }else
        {
          DEBUG_OUT("Demo.TXT created in the disk error.\r\n\r\n");
        }        
        scan_files(path);
        SD_TotalSize(path);
    } 
    
//    if(W25QXX_Init() == 0)
//    {
//        //==================================================
////        W25QXX_EraseChip(); //ȫƬ
////        W25QXX_Read(addr,buf,512);
////        DEBUG_OUT("W25QXX_EraseChip W25QXX_Read 0x0000 Data:");
////        p = buf;
////        elog_hexdump("",16,p,512);
////
////        res = f_mkfs("1:",FM_FAT|FM_SFD,512,buf,512);   //ϵͳʽ
////        if(res == 0)    DEBUG_OUT("f_mkfs disk 1!\r\n");
////        else    DEBUG_OUT("f_mkfs disk 1 fail *** %d ***!\r\n",res);
//
//        //====================================================
//        res = f_mount(&fs,"1:",1);
//        DEBUG_OUT("\r\nf_mount disk1 res=%d!\r\n",res);
//        if(res == FR_NO_FILESYSTEM) //ļϵͳʽ
//        {
//            W25QXX_EraseChip(); //ȫƬ
//            res = f_mkfs("1:",FM_FAT|FM_SFD,1024,buf,1024);
//            DEBUG_OUT("f_mkfs disk1 res=%d!\r\n",res);
//            res = f_mount(&fs,"1:",1);
//        }
//        if(res == 0)
//        {
//          res = f_open( &fsrc , "1:/test.TXT" , FA_OPEN_APPEND | FA_WRITE | FA_READ);
//          if ( res == FR_OK )
//          {
//              /* Write buffer to file */
//              res = f_write(&fsrc, textFileBuffer, sizeof(textFileBuffer), &br);
//              DEBUG_OUT("Demo.TXT successfully created        \r\n\r\n");
//
//          }else if ( res == FR_EXIST )
//          {
//              /* Write buffer to file */
//              res = f_write(&fsrc, textFileBuffer, sizeof(textFileBuffer), &br);
//              DEBUG_OUT("Demo.TXT created in the disk1      \r\n\r\n");
//          }else
//          {
//              DEBUG_OUT("Demo.TXT created in the disk1 error %d.\r\n\r\n",res);
//          }
//
//          /*close file */
//          f_close(&fsrc);
//
//          strcpy(path,"1:");
//          scan_files(path);
//          SD_TotalSize(path);
//        }
//    }
//

//    for(addr = 0;addr < 0x20000;addr+=512)
//    {
//        W25QXX_Read(addr,buf,512);
//        DEBUG_OUT("W25QXX_Read 0x%X Data:",addr);
//        p = buf;
//        elog_hexdump("",16,p,512);
//    }
    

    
 #undef     LOG_TAG
 #define    LOG_TAG     "MAIN-TAG"   
             
        log_a("log a000.\n");
        log_e("log e111.\n");
        log_w("log w222.\n");
        log_i("log i333.\n");
        log_d("log d444.\n");
        log_v("log v555.\n");
        
        while(1);
}




